---
title: '<bdi>: The Bidirectional Isolate element'
slug: Web/HTML/Element/bdi
tags:
  - BDI
  - BiDi
  - Directionality
  - Element
  - HTML
  - HTML text-level semantics
  - 'HTML:Flow content'
  - 'HTML:Palpable Content'
  - 'HTML:Phrasing content'
  - Internationalization
  - Left-to-Right
  - Reference
  - Right-to-left
  - Text
  - Web
  - direction
  - i18n
  - ltr
  - rtl
---
<div>{{HTMLRef}}</div>

<p><span class="seoSummary">The HTML <strong>Bidirectional Isolate element</strong> (<strong><code>&lt;bdi&gt;</code></strong>)  tells the browser's bidirectional algorithm to treat the text it contains in isolation from its surrounding text.</span> It's particularly useful when a website dynamically inserts some text and doesn't know the directionality of the text being inserted.</p>

<div>{{EmbedInteractiveExample("pages/tabbed/bdi.html", "tabbed-standard")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>Bidirectional text is text that may contain both sequences of characters that are arranged left-to-right (LTR) and sequences of characters that are arranged right-to-left (RTL), such as an Arabic quotation embedded in an English string. Browsers implement the <a href="https://www.w3.org/International/articles/inline-bidi-markup/uba-basics">Unicode Bidirectional Algorithm</a> to handle this. In this algorithm, characters are given an implicit directionality: for example, Latin characters are treated as LTR while Arabic characters are treated as RTL. Some other characters (such as spaces and some punctuation) are treated as neutral and are assigned directionality based on that of their surrounding characters.</p>

<p>Usually, the bidirectional algorithm will do the right thing without the author having to provide any special markup but, occasionally, the algorithm needs help. That's where <code>&lt;bdi&gt;</code> comes in.</p>

<p>The <code>&lt;bdi&gt;</code> element is used to wrap a span of text and instructs the bidirectional algorithm to treat this text in isolation from its surroundings. This works in two ways:</p>

<ul>
 <li>The directionality of text embedded in <code>&lt;bdi&gt;</code> <em>does not influence</em> the directionality of the surrounding text.</li>
 <li>The directionality of text embedded in <code>&lt;bdi&gt;</code> <em>is not influenced by</em> the directionality of the surrounding text.</li>
</ul>

<p>For example, consider some text like:</p>

<pre class="no-line-numbers">EMBEDDED-TEXT - 1st place</pre>

<p>If <code>EMBEDDED-TEXT</code> is LTR, this works fine. But if <code>EMBEDDED-TEXT</code> is RTL, then  <code> - 1</code> will be treated as RTL text (because it consists of neutral and weak characters). The result will be garbled:</p>

<pre class="no-line-numbers">1 - EMBEDDED-TEXTst place</pre>

<p>If you know the directionality of <code>EMBEDDED-TEXT</code> in advance, you can fix this problem by wrapping <code>EMBEDDED-TEXT</code> in a {{HTMLElement("span")}} with the {{htmlattrxref("dir")}} attribute set to the known directionality. But if you don't know the directionality - for example, because <code>EMBEDDED-TEXT</code> is being read from a database or entered by the user - you should use <code>&lt;bdi&gt;</code> to prevent the directionality of <code>EMBEDDED-TEXT</code> from affecting its surroundings.</p>

<p>Though the same visual effect can be achieved using the CSS rule {{cssxref("unicode-bidi")}}<code>: isolate</code> on a {{HTMLElement("span")}} or another text-formatting element, HTML authors should not use this approach because it is not semantic and browsers are allowed to ignore CSS styling.</p>

<p>Embedding the characters in <code>&lt;span dir="auto"&gt;</code> has the same effect as using <code>&lt;bdi&gt;</code>, but its semantics are less clear.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row"><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
   <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">Flow content</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>, palpable content.</td>
  </tr>
  <tr>
   <th scope="row">Permitted content</th>
   <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">Phrasing content</a>.</td>
  </tr>
  <tr>
   <th scope="row">Tag omission</th>
   <td>{{no_tag_omission}}</td>
  </tr>
  <tr>
   <th scope="row">Permitted parents</th>
   <td>Any element that accepts <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>.</td>
  </tr>
  <tr>
   <th scope="row">Implicit ARIA role</th>
   <td><a href="https://www.w3.org/TR/html-aria/#dfn-no-corresponding-role">No corresponding role</a></td>
  </tr>
  <tr>
   <th scope="row">Permitted ARIA roles</th>
   <td>Any</td>
  </tr>
  <tr>
   <th scope="row">DOM interface</th>
   <td>{{domxref("HTMLElement")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Attributes">Attributes</h2>

<p>Like all other HTML elements, this element supports the <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>, except that the {{htmlattrxref("dir")}} attribute behaves differently than normal: it defaults to <code>auto</code>, meaning its value is never inherited from the parent element. This means that unless you specify a value of either <code>rtl</code> or <code>ltr</code> for <code>dir</code>, the {{Glossary("user agent")}} will determine the correct directionality to use based on the contents of the <code>&lt;bdi&gt;</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="No_&lt;bdi&gt;_with_only_LTR">No &lt;bdi&gt; with only LTR</h3>

<p>This example lists the winners of a competition using {{HTMLElement("span")}} elements only. When the names only contain LTR text the results look fine:</p>

<div id="bdi-sample-1">
<pre class="brush: html">&lt;ul&gt;
 &lt;li&gt;&lt;span class="name"&gt;Henrietta Boffin&lt;/span&gt; - 1st place&lt;/li&gt;
 &lt;li&gt;&lt;span class="name"&gt;Jerry Cruncher&lt;/span&gt; - 2nd place&lt;/li&gt;
&lt;/ul&gt;
</pre>

<div class="hidden">
<pre class="brush: css">body {
  border: 1px solid #3f87a6;
  max-width: calc(100% - 40px - 6px);
  padding: 20px;
  width: calc(100% - 40px - 6px);
  border-width: 1px 1px 1px 5px;
}
</pre>
</div>
</div>

<p>{{ EmbedLiveSample('bdi-sample-1','','120','','','bdi-example') }}</p>

<h3 id="No_&lt;bdi&gt;_with_RTL_text">No &lt;bdi&gt; with RTL text</h3>

<p>This example lists the winners of a competition using {{HTMLElement("span")}} elements only, and one of the winners has a name consisting of RTL text. In this case the "<code>- 1</code>", which consists of characters with neutral or weak directionality, will adopt the directionality of the RTL text, and the result will be garbled:</p>

<div id="bdi-sample-2">
<pre class="brush: html">&lt;ul&gt;
 &lt;li&gt;&lt;span class="name"&gt;اَلأَعْشَى&lt;/span&gt; - 1st place&lt;/li&gt;
 &lt;li&gt;&lt;span class="name"&gt;Jerry Cruncher&lt;/span&gt; - 2nd place&lt;/li&gt;
&lt;/ul&gt;
</pre>

<div class="hidden">
<pre class="brush: css">body {
  border: 1px solid #3f87a6;
  max-width: calc(100% - 40px - 6px);
  padding: 20px;
  width: calc(100% - 40px - 6px);
  border-width: 1px 1px 1px 5px;
}
</pre>
</div>
</div>

<p>{{ EmbedLiveSample('bdi-sample-2','','120','','','bdi-example') }}</p>

<h3 id="Using_&lt;bdi&gt;_with_LTR_and_RTL_text">Using &lt;bdi&gt; with LTR and RTL text</h3>

<p>This example lists the winners of a competition using <code> &lt;bdi&gt;</code> elements. These elements instruct the browser to treat the name in isolation from its embedding context, so the example output is properly ordered:</p>

<div id="bdi-sample-3">
<pre class="brush: html">&lt;ul&gt;
 &lt;li&gt;&lt;bdi class="name"&gt;اَلأَعْشَى&lt;/bdi&gt; - 1st place&lt;/li&gt;
 &lt;li&gt;&lt;bdi class="name"&gt;Jerry Cruncher&lt;/bdi&gt; - 2nd place&lt;/li&gt;
&lt;/ul&gt;
</pre>

<div class="hidden">
<pre class="brush: css">body {
  border: 1px solid #3f87a6;
  max-width: calc(100% - 40px - 6px);
  padding: 20px;
  width: calc(100% - 40px - 6px);
  border-width: 1px 1px 1px 5px;
}
</pre>
</div>
</div>

<p>{{ EmbedLiveSample('bdi-sample-3','','120','','','bdi-example') }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'semantics.html#the-bdi-element', '&lt;bdi&gt;')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'textlevel-semantics.html#the-bdi-element', '&lt;bdi&gt;')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("html.elements.bdi")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.w3.org/International/articles/inline-bidi-markup/">Inline markup and bidirectional text in HTML</a></li>
 <li><a href="https://www.w3.org/International/articles/inline-bidi-markup/uba-basics">Unicode Bidirectional Algorithm basics</a></li>
 <li><a href="/en-US/docs/Web/Localization">Localization and Internationalization</a></li>
 <li>Related HTML element: {{HTMLElement("bdo")}}</li>
 <li>Related CSS properties: {{cssxref("direction")}}, {{cssxref("unicode-bidi")}}</li>
</ul>
